#include <iostream>
#include <algorithm>

using namespace std;

/**
U sumi ima X stabala.
Dvojica drvosjeca sijeku stabla u toj sumi.
Prvi posijece A stabala dnevno, a drugi B stabala dnevno.
Prvi odmara svakog Ktog dana (Ktog, 2Ktog, 3Ktog,...), a drugi odmara svakog Mtog dana.
Napisati program koji izracunava koliko je dana potrebno drvosjecama da posijeku citavu sumu.
Pretpostavke: A>0, B>0, K>1, M>1.
Primjer: X = 35, A = 4, B = 3, K = 2, M = 3 -> treba im 9 dana
*/
int broj_posjecenih(int a, int b, int k, int m, int d) {
    return (d - d/k)*a + (d - d/m)*b;
}

int drvosjece(int x, int a, int b, int k, int m) {
    int l = 1;
    int r = x;
    int rjesenje = 0;

    while (l <= r) {
        int d = (l + r)/2;
        int broj = broj_posjecenih(a, b, k, m, d);
        if (broj >= x) {
            rjesenje = d;
            r = d - 1;
        }
        else {
            l = d + 1;
        }
    }

    return rjesenje;
}

void print_array(int a[], int n) {
    for (int i = 0; i < n; i++) {
        cout << a[i] << " ";
    }
    cout << endl;
}

void bubble_sort(int a[], int n) {
    for (int i = 0; i < n-1; i++) {
        bool swapped = false;
        for (int j = 0; j < n-1-i; j++) {
            if (a[j] > a[j+1]) {
                swap(a[j], a[j+1]);
                swapped = true;
            }
        }
        if (swapped == false) {
            return;
        }
    }
}

void selection_sort(int a[], int n) {
    for (int i = 0; i < n-1; i++) {
        int min_idx = i;
        for (int j = i+1; j < n; j++) {
            if (a[j] < a[min_idx]) {
                min_idx = j;
            }
        }
        swap(a[i], a[min_idx]);
    }
}

int q_partition(int a[], int l, int r) {
    int pivot = a[r];
    int p = l;
    for (int i = l; i <= r-1; i++) {
        if (a[i] < pivot) {
            swap(a[i], a[p]);
            p++;
        }
    }
    swap(a[p], a[r]);
    return p;
}

void quick_sort(int a[], int l, int r) {
    if (l >= r) {
        return;
    }
    int p = q_partition(a, l, r);
    quick_sort(a, l, p-1);
    quick_sort(a, p+1, r);
}

void merge_partitions(int a[], int l, int r, int m) {
    int left[m-l+1];
    int right[r-m];

    for (int i = l; i <= m; i++) {
        left[i-l] = a[i];
    }
    for (int i = m+1; i <= r; i++) {
        right[i-m-1] = a[i];
    }

    int l_idx = 0, r_idx = 0, i = l;

    while (l_idx < m-l+1 && r_idx < r-m) {
        if (left[l_idx] < right[r_idx]) {
            a[i] = left[l_idx];
            l_idx++;
        }
        else {
            a[i] = right[r_idx];
            r_idx++;
        }
        i++;
    }

    while (l_idx < m-l+1) {
        a[i] = left[l_idx];
        l_idx++;
        i++;
    }
    while (r_idx < r-m) {
        a[i] = right[r_idx];
        r_idx++;
        i++;
    }
}

void merge_sort(int a[], int l, int r) {
    if (l >= r) {
        return;
    }
    int m = (l + r)/2;
    merge_sort(a, l, m);
    merge_sort(a, m+1, r);
    merge_partitions(a, l, r, m);
}

bool rastuci(int x, int y) {
    return x < y;
}
bool opadajuci(int x, int y) {
    return x > y;
}

int main()
{
    int x = 35, a = 4, b = 3, k = 2, m = 3;
    cout << drvosjece(x, a, b, k, m) << endl;

    int n = 11;
    int niz[] = {9, 8, 67, 98, 3, 15, 51, 5, 15, 27, 16};

    //bubble_sort(niz, n);
    //selection_sort(niz, n);
    //quick_sort(niz, 0, n-1);
    //merge_sort(niz, 0, n-1);

    sort(niz, niz+n, opadajuci);

    print_array(niz, n);

    return 0;
}
